//+------------------------------------------------------------------+
//|                                                          EMI.mq4 |
//|                                 Copyright  2009, Roman Robidet. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Roman Robidet."

#property indicator_separate_window
//#property indicator_minimum 0
//#property indicator_maximum 100
#property indicator_level1 0.0
#property indicator_buffers 1
#property indicator_color1 DodgerBlue

extern int EMIPeriod=14;

double EMIBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
    string short_name;
    IndicatorBuffers (1);
//---- indicator line
    SetIndexStyle (0, DRAW_LINE);
    SetIndexBuffer (0, EMIBuffer);
//---- name for DataWindow and indicator subwindow label
    short_name = "EMI(" + EMIPeriod + ")";
    IndicatorShortName (short_name);
    SetIndexLabel (0, short_name);
//----
    return (INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
    int  k, limit, Bar;
    double _H, sumaEMI, EMV, _AV, _B, _HP, _BP, _V;
//----
    if (rates_total == prev_calculated) return (rates_total);
    limit = rates_total - prev_calculated + 1;
//-- main loop
   
    for (int i = limit; i >= 0; i--)
    {
        sumaEMI = 0.;
        for (k = 0; k < EMIPeriod; k++)
        {
            Bar = i + k;
            _V = tick_volume[Bar];
            if (_V == 0.) {Print ("    ", Bar, "-  !!!"); continue;}
            _H = high[Bar];
            _B = low[Bar];
            _HP = high[Bar+1];
            _BP = low[Bar+1];
            _AV = _H - _B;
            if (_AV != 0.) EMV = (((_H + _B) / 2.) - ((_HP + _BP) / 2.)) / (_V / _AV) * 10000000000 ;
            sumaEMI += EMV;
        }
        EMIBuffer[i] = (sumaEMI / EMIPeriod);
    }
//----
    return (rates_total);
}
//+------------------------------------------------------------------+